# Change Log

All notable changes to this project will be documented in this file
automatically by Versionist. DO NOT EDIT THIS FILE MANUALLY!
This project adheres to [Semantic Versioning](http://semver.org/).

# v6.9.2
## (2020-10-23)

* Update dev dependencies [Pagan Gazzard]

# v6.9.1
## (2020-09-17)

* Improve typings [Pagan Gazzard]

# v6.9.0
## (2020-09-07)

* Add 'getOrCreate' method supporting natural keys [Thodoris Greasidis]

# v6.8.0
## (2020-09-03)

* Add support for $format [Pagan Gazzard]

# v6.7.3
## (2020-08-26)

* Improve $orderby typing to allow `[{a: 'desc'}, {b: 'asc'}]` [Pagan Gazzard]

# v6.7.2
## (2020-08-24)

* Update dev dependencies [Pagan Gazzard]

# v6.7.1
## (2020-08-12)

* Fix prepare $count typings [Pagan Gazzard]

# v6.7.0
## (2020-08-12)

* Improve typings for request/post/put/patch/delete [Pagan Gazzard]

# v6.6.1
## (2020-08-11)

* Fix typing when id is specified to be `AnyObject | undefined` [Pagan Gazzard]

# v6.6.0
## (2020-08-11)

* Deprecate `$expand: { 'a/$count': {...} }` [Pagan Gazzard]
* Deprecate `resource: 'a/$count'` and update typings to reflect it [Pagan Gazzard]

# v6.5.0
## (2020-08-11)

* Add `options: { $count: { ... } }` sugar for top level $count [Pagan Gazzard]
* Add `$expand: { a: { $count: { ... } } }` sugar for $count in expands [Pagan Gazzard]

# v6.4.0
## (2020-08-11)

* Improve return typing of `subscribe` method [Pagan Gazzard]

# v6.3.0
## (2020-08-11)

* Fix Poll.on typings [Pagan Gazzard]
* Improve return typing when id is passed to GET methods [Pagan Gazzard]
* Remove `PromiseResult` type, use `Promise<PromiseResultTypes>` instead [Pagan Gazzard]
* Remove `PromiseObj` type, use `Promise<{}>` instead [Pagan Gazzard]

# v6.2.0
## (2020-08-10)

* Add `$filter: { a: { $count: 1 } }` sugar for $count in filters [Pagan Gazzard]

# v6.1.2
## (2020-08-10)

* Remove redundant ParamsObj/SubscribeParamsObj types [Pagan Gazzard]

# v6.1.1
## (2020-08-10)

* Make use of `mapObj` helper in more places [Pagan Gazzard]
* Use `Object.keys` in preference to `hasOwnProperty` where applicable [Pagan Gazzard]

# v6.1.0
## (2020-07-21)

* Add support for using named ids [Pagan Gazzard]

# v6.0.1
## (2020-06-19)

* Drop unnecessary async from request() [Thodoris Greasidis]

# v6.0.0
## (2020-06-04)

* Increase minimum es version to es2015 [Pagan Gazzard]
* Convert to async/await [Pagan Gazzard]
* Remove now unnecessary PinejsClientCoreFactory [Pagan Gazzard]
* Switch to using native promises [Pagan Gazzard]
* Drop support for deprecated request overrides [Pagan Gazzard]
* Drop support for deprecated `query` method [Pagan Gazzard]
* Drop support for deprecated string based requests [Pagan Gazzard]
* Use `;` for expand options instead of `&` [Pagan Gazzard]

# v5.8.0
## (2020-05-29)

* Generate optional builds for es2015/es2018 as well as the default es5 [Pagan Gazzard]

# v5.7.1
## (2020-05-25)

* Update dependencies [Pagan Gazzard]

# v5.7.0
## (2020-04-15)

* Make transformGetResult a method , to ease overriding the get method [Thodoris Greasidis]

## 5.6.11 - 2020-02-21

* 🐛: Fix missing `deprecated.getStringParams` function [Andreas Fitzek]

## 5.6.10 - 2020-02-14

* Update to resin-lint 3.x [Pagan Gazzard]

## 5.6.9 - 2020-02-14

* CircleCI: Remove deploy job as it's handled by balenaCI [Pagan Gazzard]

## 5.6.8 - 2020-02-14

* Add the missing `method` on the post method [Thodoris Greasidis]

## 5.6.7 - 2020-02-14

* Deprecate request overrides [Pagan Gazzard]
* Deprecate queries using a string url [Pagan Gazzard]
* Deprecate `query` in favor of `get` [Pagan Gazzard]

## 5.6.6 - 2020-02-14

* Allow resource/$count in $filter [Pagan Gazzard]

## 5.6.5 - 2020-01-30

* Remove `defaults` helper in favour of `??` [Pagan Gazzard]

## 5.6.4 - 2020-01-30

* Avoid allocations when destroying a poll [Pagan Gazzard]

## 5.6.3 - 2020-01-30

* Improve `RawFilter` typing [Pagan Gazzard]

## 5.6.2 - 2020-01-29

* Update dependencies [Pagan Gazzard]

## 5.6.1 - 2020-01-22

* Switch most CODEOWNERS entries to a team [Pagan Gazzard]

## 5.6.0 - 2019-07-12

* Add 'upsert' method supporting natural keys, requires Pinejs ^10.19.1 [Thodoris Greasidis]

## 5.5.4 - 2019-06-18

* Remove unnecessary `string` type that is handled by the `Params` type [Pagan Gazzard]

## 5.5.3 - 2019-06-18

* Use an .npmrc to prevent creating a package-lock on each install [Thodoris Greasidis]

## 5.5.2 - 2019-06-10

* Add some type casting so that it compiles on TypeScript 3.5 [Thodoris Greasidis]

## 5.5.1 - 2019-05-15

* Fix downstream declaration creation errors due to `Dictionary` [Pagan Gazzard]

## 5.5.0 - 2019-05-15

* Add a prepare method that prepares a query into a function [Pagan Gazzard]

## 5.4.1 - 2019-05-10

* Add CODEOWNERS [Gergely Imreh]

## 5.4.0 - 2019-05-10

* Add support for parameter aliases in resource ids [Pagan Gazzard]

## 5.3.10 - 2019-05-10

* Deduplicate transformation of GET results [Pagan Gazzard]

## 5.3.9 - 2019-05-10

* Simplify how we expose types, which means `subscribe` is now exposed [Pagan Gazzard]

## 5.3.8 - 2019-05-09

* Add automatic formatting via prettier [Pagan Gazzard]

## 5.3.7 - 2019-05-08

* Remove node 4 build, add node 12 [Pagan Gazzard]
* Add .versionbot/CHANGELOG.yml for downstream changelogs [Pagan Gazzard]

## 5.3.6 - 2019-01-21

* Fix `passthroughByMethod` typing [Pagan Gazzard]

## v5.3.5 - 2018-10-18

* Make the abstract `overrides` signature optional [Pagan Gazzard]

## v5.3.4 - 2018-09-11

* Switch to using `ReturnType` now that we can [Pagan Gazzard]

## v5.3.3 - 2018-09-07

* Throw errors on empty $select or $orderby arrays as they're invalid [Pagan Gazzard]

## v5.3.2 - 2018-08-27

* Fix expand type #65 [Pagan Gazzard]

## v5.3.1 - 2018-08-15

* Use a native in for `$in` when all elements are primitive #64 [Pagan Gazzard]

## v5.3.0 - 2018-08-08

* Explicitly allow suffixing `/$count` onto resources #63 [Pagan Gazzard]

## v5.2.0 - 2018-06-14

* Add support for parameter aliases #62 [Pagan Gazzard]

## v5.1.0 - 2018-05-17

* Skip lib checks in tsconfig.json #61 [Pagan Gazzard]
* Exclude `node_modules` from tsconfig.json #61 [Pagan Gazzard]
* Remove unnecessary brackets from expands with an empty options object. #61 [Pagan Gazzard]
* Remove unnecessary brackets from function call parameters. #61 [Pagan Gazzard]
* Remove unnecessarily nested brackets. #61 [Pagan Gazzard]

## v5.0.3 - 2018-05-01

* Switch to using generated declaration files for types #60 [Pagan Gazzard]

## v5.0.2 - 2018-04-30

* Add node 10 to the circleci tests #59 [Pagan Gazzard]

## v5.0.1 - 2018-03-30

* Allow numbers and booleans for custom options.coffee #58 [Pagan Gazzard]

## v5.0.0 - 2018-03-29

* Change to the subscribe pollInterval to be the amount of time between the response of one poll until the start of the next, avoiding cases where we can have multiple ongoing requests if the interval is lower than the response time. #54 [Pagan Gazzard]
* Stop requiring a utils object be provided as the final `isObject` function is now handled internally. #54 [Pagan Gazzard]
* Stop requiring an `isDate` function be provided #54 [Pagan Gazzard]
* Stop requiring that an `isBoolean` function be provided and instead use a simple check that requires only primitive booleans be used (not wrapped in a Boolean object) #54 [Pagan Gazzard]
* Stop requiring that an `isString` function be provided and instead use a simple check that requires only primitive strings be used (not wrapped in a String object) #54 [Pagan Gazzard]
* Stop requiring that an `isNumber` function be provided and instead use `Number.isFinite` semantics for number checking #54 [Pagan Gazzard]
* Stop requiring that an `isArray` function be provided and instead use `Array.isArray`, drops supports for some very old browsers. #54 [Pagan Gazzard]
* Switch to `Array.prototype.map` dropping support for some very old browsers. #54 [Pagan Gazzard]
* Remove deprecated `customOptions` #54 [Pagan Gazzard]
* Remove deprecated expand behaviour #54 [Pagan Gazzard]
* Separate the request backend to pinejs-client-request #54 [Pagan Gazzard]
* Switch to a named `PinejsClientCoreFactory` export, rather than directly exporting the function #54 [Pagan Gazzard]
* Include the `$` in error messages to avoid potential confusion #54 [Pagan Gazzard]
* Switch to a commonjs module in preference to UMD #54 [Pagan Gazzard]
* Move type dependencies from dev to normal dependencies, so they are available to users of this module. #54 [Pagan Gazzard]
* Remove deprecated automatic $ prefixing for `options`, and deprecate `customOptions` #54 [Pagan Gazzard]
* Convert core to typescript #54 [Pagan Gazzard]
* Remove bower.json #54 [Pagan Gazzard]

## v4.3.2 - 2018-03-14

* Switch to circleci and enable auto-publishing #56 [Pagan Gazzard]

## v4.3.1 - 2018-03-08

* Fix expand typings, by making sure that the ODataOptions are only valid within a resource expand #55 [Pagan Gazzard]

## v4.3.0 - 2018-01-29

* Add 'subscribe' method for repeated requests for the same resource #51 [Lucian Buzzo]

## v4.2.4 - 2017-11-17

* Filters can now accept values of different base types. In particular null | Date |boolean have been added. Previously it would only accept number | string #48 [Giovanni Garufi]

## v4.2.3 - 2017-10-23

* Fix typing for request, previously no class type was defined due to exporting a class expression. #45 [Pagan Gazzard]
* Add a .travis.yml to test on travisci #45 [Pagan Gazzard]

## v4.2.2 - 2017-10-09

* Fix type for the Promise.reject
* Fix type of `_request` in request.d.ts
* Allow passing in the promise types in order to get a correctly typed promise returned

## v4.2.1

* Correctly type _request as a member function rather than a property
* Export a lot more of the types so they can be used by external typescript
* Merge properties into FilterObj directly, as the & merging doesn't work as expected
* Export the AnyObject type so it can be used for typing that we know the response will match it
* Fix clone typings
* Fixed util typings

## v4.2.0

* Changed options to avoid prepending `$` to options that already have `$` prepended, allowing them to be used and work
* Deprecated omitting the leading `$` in options

## v4.1.1

* Fixed types definition to make `backendParams` optional

## v4.1.0

* Added types for request and core.

## v4.0.0

* Added support for properly validating the contents of `$orderby`, `$select`, `$skip`, and `$top`

## v3.1.0

* Added support for empty expand object options (`expand: a: {}`)

## v3.0.0

* Added support for dates
* Breaking change: Utils must now provide an `isDate` method.

## v2.4.0

* Throw an error if the id property is set but is empty.

## v2.3.2

* Throw the correct error when an invalid resource is passed to `escapeResource`

## v2.3.1

* Fixed spurious deprecation notice on cases like `$expand: a: $select: 'b'`

## v2.3.0

* Deprecated `$expand: a: b: ...`
* Deprecated `$expand: a: "b"`
* Deprecated `$filter: a: b: ...`
* Added support for array and object forms of `$raw` which allows use of bindings for automatic processing of filter fragments and escaping of values.

## v2.2.0

* Updated request backend to lodash ^4.0.0

## v2.1.1

* Correctly escape single quotes in strings.

## v2.1.0

* Added support for the `any` and `all` lambda operators.

## v2.0.1

* Commit missed request.js changes.

## v2.0.0

* Updated request backend to use bluebird 3.
* Added a nice error message when an option without special handling isn't a string or array.

## v1.6.0

* Add suport for nested expands and expand options in the style `a: $expand: b: $select: 'c'`

## v1.5.0

* Added support for operator objects with only one value, eg `a: $ne: $: 'b'`
* Added status code to thrown errors from the request backend.

## v1.4.0

* Require a valid SSL certificate for the request backend by default.

## v1.3.1

* Fixed the request timeout value to be 30s instead of 30ms.

## v1.3.0

* Made sure that $in filters can be specified with arrays of length 1
* Default to 30s timeout for request, rather than hanging indefinitely.

## v1.2.0

* Added the concept of backend parameters via `new PinejsClient(params, backendParams)` and `.clone(params, backendParams)`
* Added a `cache` backend parameter to the request backend, which is used to create a bluebird-lru-cache cache for GET request ETags.

## v1.1.0

* Added a `compile` function that can be used to compile a request object to a url without sending off an actual request.
* Fixed the case of passing no params to the constructor/clone methods.

## v1.0.0

* Initial release
